#pragma once

#include <tuple>
#include <type_traits>
#include <utility>

#include <dune/common/hash.hh>

namespace AMDiS
{
  namespace Impl
  {
    // Recursive template code derived from Matthieu M.
    template <class Tuple, std::size_t I = std::tuple_size<Tuple>::value - 1>
    struct HashTupleImpl
    {
      static void apply(size_t& seed, Tuple const& tuple)
      {
        HashTupleImpl<Tuple, I-1>::apply(seed, tuple);
        Dune::hash_combine(seed, std::get<I>(tuple));
      }
    };

    template <class Tuple>
    struct HashTupleImpl<Tuple, 0>
    {
      static void apply(std::size_t& seed, Tuple const& tuple)
      {
        Dune::hash_combine(seed, std::get<0>(tuple));
      }
    };

  } // end namespace Impl

} // end namespace AMDiS
